package org.crosswire.android.bishop;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;

import org.crosswire.android.sword.InstallMgr;
import org.crosswire.android.sword.SWMgr;
import org.crosswire.android.sword.SWMgr.ModInfo;

import android.app.Activity;
import android.app.ProgressDialog;
import android.app.TabActivity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.Spinner;
import android.widget.TabHost;
import android.widget.TabWidget;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.LinearLayout.LayoutParams;

public class Installer extends TabActivity {
	
	LinearLayout mainLayout;
	InstallMgr installMgr = new InstallMgr();
    ProgressDialog progress;

	protected void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
		
		TabHost tabHost = new TabHost(this);
		tabHost.setId(android.R.id.tabhost);
		
		mainLayout = new LinearLayout(this);
		mainLayout.setOrientation(LinearLayout.VERTICAL);
		tabHost.addView(mainLayout);
		
		TabWidget tabs = new TabWidget(this);
		tabs.setId(android.R.id.tabs);
		mainLayout.addView(tabs);
		
		FrameLayout tabContents = new FrameLayout(this);
		tabContents.setId(android.R.id.tabcontent);
		mainLayout.addView(tabContents);
		
		setContentView(tabHost, new LinearLayout.LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
		
		// First tab
		TabHost.TabSpec userTab = tabHost.newTabSpec("Installed");
		userTab.setContent(new Intent(this,Installed.class));
		userTab.setIndicator("Installed");
		tabHost.addTab(userTab);

		// Second tab
		TabHost.TabSpec secTab = tabHost.newTabSpec("Available");
		secTab.setContent(new Intent(this,Available.class));
		secTab.setIndicator("Available");
		tabHost.addTab(secTab);
		
	    progress = new ProgressDialog(this);
	    
		installMgr.setUserDisclaimerConfirmed();
		
		updateConfigInfo();
		
	}
	
	private static final int REPORT_PROGRESS = Menu.FIRST + 1;
	private static final int PROGRESS_FINISHED = Menu.FIRST + 2;
	
	Handler myHandler = new Handler() {

		public void handleMessage(Message msg) {
			switch (msg.what) {
			case REPORT_PROGRESS:
//				progress.setProgress(msg.getData().getInt("progress"));
			    progress.setMessage(msg.getData().getString("message"));
				break;
			case PROGRESS_FINISHED:
				progress.hide();
				break;
			default:
				super.handleMessage(msg);
			}
		}
	};
	
	public void updateConfigInfo() {
	    progress.setTitle("Updating Available Resource Knowledge");
//	    progress.setMax(100);
//	    progress.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
	    progress.show();
		new Thread(new Runnable() {
			
			public void run() {
				Message m = myHandler.obtainMessage(REPORT_PROGRESS);
				Bundle b = new Bundle();
				b.putString("message", "Discovering Publishers...");
				m.setData(b);
				myHandler.sendMessage(m);
				
				int result = installMgr.syncConfig();
				if (result != 0) {
					System.err.println("Problem syncing configs. " + result);
				}
				
				for (String source: installMgr.listRemoteSources()) {
					m = myHandler.obtainMessage(REPORT_PROGRESS);
					b = new Bundle();
					b.putString("message", "Sync with " + source + "...");
					m.setData(b);
					myHandler.sendMessage(m);
				    installMgr.refreshRemoteSource(source);
				}
				m = myHandler.obtainMessage(PROGRESS_FINISHED);
				myHandler.sendMessage(m);
    		}
		}).start();
	}
	
	
	
	public static class Available extends Activity {
	
		InstallMgr installMgr = new InstallMgr();
		LinearLayout mainLayout;
		ListView modList;
		Spinner sources;
		Vector<HashMap<String,String>> sourcesModel = new Vector<HashMap<String,String>>();
		ArrayList<String> sourceList = new ArrayList<String>();
		Vector<HashMap<String,String>> modulesModel = new Vector<HashMap<String,String>>();
		ArrayAdapter<String> aadapter;
		SimpleAdapter sadapter;
	    ProgressDialog progress;
		
		protected void onCreate(Bundle savedInstanceState) {
			super.onCreate(savedInstanceState);
			this.setTitle("Available Modules");
			mainLayout = new LinearLayout(this);
			mainLayout.setOrientation(LinearLayout.VERTICAL);
			
			String[] columns = new String[] {"name"};
			int[] names = new int[] {android.R.id.text1};
			//SimpleAdapter adapter = new SimpleAdapter(this, sourcesModel, android.R.layout.simple_spinner_item, columns, names);
			sources = new Spinner(this);
			sources.setPadding(10, 10, 10, 10);
			
			aadapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, sourceList);       
			aadapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);                  
			sources.setAdapter(aadapter);
			sources.setPrompt("Choose Source");
			sources.setOnItemSelectedListener(new OnItemSelectedListener() {
				public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
					sourceChanged();
				}
				public void onNothingSelected(AdapterView<?> arg0) {
				}
			});

			mainLayout.addView(sources);
			
			columns = new String[] {"name", "desc"};
			names = new int[] {android.R.id.text1, android.R.id.text2};
			sadapter = new SimpleAdapter(this, modulesModel, android.R.layout.simple_list_item_2, columns, names);
			modList = new ListView(this);
			modList.setPadding(10, 10, 10, 10);
			modList.setAdapter(sadapter);
			modList.setOnCreateContextMenuListener(this);
			mainLayout.addView(modList);
			
			addContentView(mainLayout, new LinearLayout.LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
			loadSources();
			loadMods();
		    progress = new ProgressDialog(this);
		}
		Handler myHandler = new Handler() {

			public void handleMessage(Message msg) {
				switch (msg.what) {
				case REPORT_PROGRESS:
	//				progress.setProgress(msg.getData().getInt("progress"));
				    progress.setMessage(msg.getData().getString("message"));
					break;
				case PROGRESS_FINISHED:
					new SWMgr().reInit();
					progress.hide();
					break;
				default:
					super.handleMessage(msg);
				}
			}
		};
		
		
		public boolean onContextItemSelected(MenuItem item) {
			switch (item.getItemId()) {
			case INSTALL_MODULE:
				final String modName = (String)modList.getSelectedItem();
				final String sourceName = (String)sources.getSelectedItem();
			    progress.setTitle("Installing " + modName);
//	    progress.setMax(100);
//	    progress.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
			    progress.show();
				new Thread(new Runnable() {
			
					public void run() {
						Message m = myHandler.obtainMessage(REPORT_PROGRESS);
						Bundle b = new Bundle();
						b.putString("message", "Downloading...");
						m.setData(b);
						myHandler.sendMessage(m);
				
						int result = installMgr.remoteInstallModule(sourceName, modName);
						if (result != 0) {
							System.err.println("Problem syncing configs. " + result);
						}
				
						m = myHandler.obtainMessage(PROGRESS_FINISHED);
						myHandler.sendMessage(m);
		    		}
				}).start();
				return true;
			case ABOUT:
				return true;
			}
			return super.onContextItemSelected(item);
		}

		private static final int INSTALL_MODULE = Menu.FIRST + 1;
		private static final int ABOUT = Menu.FIRST + 2;

		public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo) {
			super.onCreateContextMenu(menu, v, menuInfo);
			menu.add(0, INSTALL_MODULE, 0, "Install Module").setShortcut('1', 'i');
			menu.add(2, ABOUT, 0, "About Module").setShortcut('2', 'a');
			menu.setGroupEnabled(2, false);
		}


		void loadSources() {
			sourceList.clear();
			for (String source : installMgr.listRemoteSources()) {
				sourceList.add(source);
			}
			sources.setAdapter(aadapter);
		}
		
		void sourceChanged() {
			loadMods();
		}
		
		
		void loadMods() {
			modulesModel.clear();
			String source = (String)sources.getSelectedItem();
			if (source != null && source.length() > 0) {
				for (ModInfo modInfo : installMgr.remoteListModules(source)) {
					HashMap<String, String> row = new HashMap<String, String>();
					if (modInfo.category.startsWith("Biblical")) {
						row.put("name", modInfo.name);
						row.put("desc", modInfo.description);
						modulesModel.add(row);
					}
				}
			}
			modList.setAdapter(sadapter);
		}
	}
	
	
	public static class Installed extends Activity {
		
		LinearLayout mainLayout;
		ListView modList;
		SWMgr mgr = new SWMgr();
		
		protected void onCreate(Bundle savedInstanceState) {
			super.onCreate(savedInstanceState);
			this.setTitle("Installed Modules");
			mainLayout = new LinearLayout(this);
			mainLayout.setOrientation(LinearLayout.VERTICAL);
			
			String[] columns = new String[] {"name", "desc"};
			int[] names = new int[] {android.R.id.text1, android.R.id.text2};
			SimpleAdapter adapter = new SimpleAdapter(this, model, android.R.layout.simple_list_item_2, columns, names);
			modList = new ListView(this);
			modList.setPadding(10, 10, 10, 10);
			modList.setAdapter(adapter);
			mainLayout.addView(modList);
			
			addContentView(mainLayout, new LinearLayout.LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
			loadMods();
		}
		
		Vector<HashMap<String,String>> model = new Vector<HashMap<String,String>>();
		
		void loadMods() {
			HashMap<String, String> row;
			for (SWMgr.ModInfo modInfo : mgr.getModInfoList()) {
				row = new HashMap<String, String>();
				row.put("name", modInfo.name);
				row.put("desc", modInfo.description);
				model.add(row);
			}
		}
		
	}

}
